using System;
using System.Globalization;
using System.Windows.Data;

namespace WpfApplication2.ValueConverters
{
    public class DataWithPresentationToTextConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (targetType == typeof(string))
                return ConvertToString(value);
            

            if (typeof(DataWithPresentation) == targetType)
                return ConvertToDataWithPresentation(value);

            return Binding.DoNothing;
        }




        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Convert(value, targetType, parameter, culture);
        }

        private static object ConvertToString(object value)
        {
            if (value == null)
                return string.Empty;

            var dataWithPresentation = value as DataWithPresentation;
            if (dataWithPresentation != null)
            {
                return dataWithPresentation.Count.ToString();

            }

            return string.Empty;
        }

        private static object ConvertToDataWithPresentation(object value)
        {
            var text = value as string;
            int count = -1;
            if (!string.IsNullOrEmpty(text) && int.TryParse(text, out count))
            {
                return new DataWithPresentation(count, State.Current);
            }

            return new DataWithPresentation(count, State.Stale);
        }
    }
}